package bham.cs.fsc;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import java.io.Serializable;
import ui.*;

/**
* An extension of the built-in random generator to supply random
* integers as well
*/
public class RandomGen extends java.util.Random implements Serializable {
    double ranDouble;
    int ranInt;
	public RandomGen(int seed) {
		super(seed);
	}
	/**
	* @return a random integer in the range 0 to n-1
	*/
	public int nextInt(int n) {
	    ranDouble = nextDouble() * n;
	    if (ranDouble < 0.5) {
		ranInt = 0;
	    }
	    else if (ranDouble < 1.0) {
		ranInt = 1;
	    }
	    else {
		ranInt = (int)ranDouble;
	    }
	    
	    return ranInt;

		//return (int)(nextDouble() * n);
	}
}

