//package exp;
package bham.cs.fsc.exp;
import java.applet.*;
import java.awt.Graphics;
import java.awt.Rectangle;
//import ApproxFrame;
import DGPFrame;
import bham.cs.fsc.ui.*;
import java.awt.Button;
import java.awt.Event;
import java.awt.Font;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.TextArea;
import java.awt.Label;
import java.awt.Color;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Choice;
import java.awt.MediaTracker;
import java.awt.Image;
import java.awt.ScrollPane;
import java.awt.Component;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.exp.*;
import java.util.Observer;
import java.util.Observable;
import java.io.*;
import java.net.*;
import java.rmi.*;
import java.util.zip.*;          // Data compression/decompression streams.
import java.awt.FileDialog;       
import java.awt.Frame;

//import com.sun.java.swing.*; //to use Swing. However, Netscape v4.05 does not support SWING properly.



/*
This applet is a generic program which demonstrates the following problems :
1) symbolic regression
2) artificial ant following the Santa Fe trail
3) artificial ant following the Los Altos Hills trail

The code is adapted from the symbolic regression GP program coded by Hans U.Gerber.

Note that it runs as a standalone Java application as well.

@version 1.0
@author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/

public class DGPClient extends Applet implements Observer, Serializable {

	// APPLICATION SUPPORT
	// Application will be set to true if it is run as a Java Application instead of as an Applet
	public boolean Application = false;

	Button startButton;
	Button pauseButton;
	Button stopButton;
	public Button settingsButton;
        //XYPlot plot;
	Histogram histogram;
	TextArea status;
	TextArea results;
        public Choice bkgdChoice;
        public Choice drawChoice;

	GP gp;
  
        Problem prob;
  //**static String probName = "SantaFe";
        public static String probName;
        //static int seed = 12345;
        //int seed = 12345;
  //**int seed = defaultSEED;
        int seed;
        static String host = "";
        PrintStream fout;
        //static int genToExport = 10;
        //static String fileName = "ClientListD.dat";

        static String title ="";

        public static DGPFrame frame;

        public imigrant i;
        static String popFileName;

        public static ThreadMonitor m;
  
  //**static String defaultPopFile = "GP.pop";

        public MediaTracker tracker;
        Image[] images;

        public static final int defaultSEED = 12345;
        public static final String defaultProbName = "SantaFe";

        String exp;
        public static boolean experiment;
        int nrOfRuns = 50;

	/**
	The main() method acts as the applet's entry point when it is run
	as a standalone application.
	It is ignored if the applet is run from	within an HTML page.
	*/
        
  public static void main(String args[]) {
  
	  try {
	    host = new String(InetAddress.getLocalHost().getHostName());
	  }
	  catch (java.net.UnknownHostException e) {
	    System.out.println("UnknownHostException in DGPClient.init() : " + e);
	    host = "unknown" ;
	  }

	  title = "Workstation : " + host + "          Problem : " + probName;
      
	  
	  //String loadFileMsg = "If this is the first time you are running this application, click on the CANCEL button and ignore this message.\n\nIf you have prematurely stopped a previous run and saved its GP population and seed into a file, please load the population and seed from the file and continue the run.\n\nClick on the LOAD FROM DEFAULT FILE' button if you have saved the population and seed into the default file " + defaultPopFile + ".\n\nIf you have saved the population and seed into a different file, click on the 'SPECIFY FILE TO LOAD' button. This will bring up another dialog for you to choose your file.\n\nIf, however, you do not wish to continue the run, please click on the 'CANCEL' button to start the run with a new population and seed.";


	  //Object[] options = {"LOAD FROM DEFAULT FILE", "SPECIFY FILE TO LOAD", "CANCEL"};

	  //JOptionPane.showOptionDialog(null,loadFileMsg,"Load File Dialog",JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,null, options, options[0]);

	  /*
	  JOptionPane pane = new JOptionPane(loadFileMsg, INFORMATION_MESSAGE, DEFAULT_OPTION,null,options, options[0]);
	  JDialog dialog = pane.createDialog(null, "Load File Dialog");
	  dialog.show();
	  

          //JFileChooser fileDialog = new JFileChooser();
	  //JFileChooser.show();
	  
	  
	  Object selectedButton = pane.getValue();
	  if (selectedButton == null) {
	    return CLOSED_OPTION;
	  }
	  
	  if (selectedButton == options[0]) {
	  */
	    
	  //popFileName = JOptionPane.showInputDialog(null,"Enter File Name","Title",JOptionPane.QUESTION_MESSAGE);
	  //System.out.println("popFileName specified by user is " + popFileName);
	
	  /*
	  LoadFileFrame fframe = new LoadFileFrame();
	  fframe.show();
	  fframe.hide();

	  fframe.show();
	  ////frame.resize(frame.insets().left + frame.insets().right  + 500,
	  ////			 frame.insets().top  + frame.insets().bottom + 400);
	  //fframe.resize(fframe.insets().left + fframe.insets().right  + 530,
	  //	       fframe.insets().top  + fframe.insets().bottom + 300);
	  fframe.pack();
	  fframe.setLocation(30,30);
	  m = new ThreadMonitor();
	  m.waitUntilFinishes();
	  
	  System.out.println("popFileName specified by user is " + popFileName);
	  */
	  

		// Create Toplevel Window to contain applet DGPClient
	        //ApproxFrame frame = new ApproxFrame("Approx");
	      
	        //DGPFrame frame = new DGPFrame(title);
	        frame = new DGPFrame(title);
		// Must show Frame before we size it so insets() will return valid values
		frame.show();
		frame.hide();

		// The following code starts the applet running within the frame window.
		// It also calls GetParameters() to retrieve parameter values from the
		// command line, and sets m_fStandAlone to true to prevent init() from
		// trying to get them from the HTML page.
		//Approx applet_Approx = new Approx();
		//DGPClient applet_DGP = new DGPClient();
		DGPClient applet_DGP = new DGPClient();
		//frame.add("Center", applet_Approx);
		frame.add("Center", applet_DGP);
		
		/*
		applet_Approx.m_fStandAlone = true;
		applet_Approx.init();
		applet_Approx.start();
		*/
	
	        applet_DGP.Application = true;
		applet_DGP.init();
		applet_DGP.start();

		frame.show();
		
		//frame.resize(frame.insets().left + frame.insets().right  + 500,
		//			 frame.insets().top  + frame.insets().bottom + 400);
		//frame.resize(frame.insets().left + frame.insets().right  + 540,
		//			 frame.insets().top  + frame.insets().bottom + 480);
		
		/*
		frame.resize(frame.insets().left + frame.insets().right  + 628,
					 frame.insets().top  + frame.insets().bottom + 564);
					 */
	
		frame.resize(frame.insets().left + frame.insets().right  + 628,
					 frame.insets().top  + frame.insets().bottom + 617);
		
                frame.setLocation(30,30);
		
	}
	
  
        public DGPClient()	{
	}
	

        public DGPClient(String probName, int seed, String popFileName)	{
	  if (probName == null) {
	    this.probName = defaultProbName;
	  }
	  else {
	    this.probName = probName;
	  }
	  if (seed == 0) {
	    this.seed = defaultSEED;
	  }
	  else {
	    this.seed = seed;
	  }

	  this.popFileName = popFileName;

	}

	public String getAppletInfo()	{
		return "Name: Distributed Interactive GP\r\n" +
		       "Author: Phyllis Chong\r\n";
	}


	/**
	The init() method is called by the AWT when an applet is first loaded or
	reloaded.	
	*/
        //public void init() {	
        public void init() {	
	  /*
	  try {
	    host = new String(InetAddress.getLocalHost().getHostName());
	  }
	  catch (java.net.UnknownHostException e) {
	    System.out.println("UnknownHostException in DGPClient.init() : " + e);
	    host = "unknown" ;
	  }
	  */
	  /*
	  try {
	  fout = new PrintStream(new FileOutputStream(host + "." + probName + ".GP.log"));
	  }
	  catch (IOException e) { 
	    System.out.println("IOException while creating fout at DGPClient.init()"); 
	  }
	  */

	  if (! Application) {
	    probName = getParameter("problem");
	    seed = defaultSEED;

                    exp = getParameter("experiment");
                    if (exp.equalsIgnoreCase( "yes")) {
                       experiment = true;
//nrOfRuns = Integer.parseInt(getParameter("nrOfRuns"));		       
	
                    }

	  }

	  prob = ProblemNames.getProblemClass(probName); 
	    

	   /*
		Panel buttonPanel = new Panel();
		//buttonPanel.setLayout(new StackLayout(StackLayout.VERTICAL));
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		//buttonPanel.add("Wide ", new Panel());	// just as a spacer
		//startButton = new Button("Start");
		//buttonPanel.add("Tall Wide ", new Panel());	// just as a spacer
		startButton = new Button("Start");
		buttonPanel.add("Tall Wide", startButton);
		pauseButton = new Button("Pause");
		buttonPanel.add("Tall Wide", pauseButton);
		stopButton = new Button("Stop");
		buttonPanel.add("Tall Wide", stopButton);
		buttonPanel.add("Tall Wide", new Panel());	// just as a spacer
		settingsButton = new Button("Settings...");
		buttonPanel.add("Tall Wide", settingsButton);                
		*/

	        //setFont(new Font("Courier",Font.PLAIN,11));
	   
	        Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.VERTICAL));
		buttonPanel.add("Wide", new Panel());	// just as a spacer
		startButton = new Button("Start");
		buttonPanel.add("Wide", startButton);
		pauseButton = new Button("Pause");
		buttonPanel.add("Wide", pauseButton);
		stopButton = new Button("Stop");
		buttonPanel.add("Wide", stopButton);
		buttonPanel.add("Wide", new Panel());	// just as a spacer
		settingsButton = new Button("Settings...");
		buttonPanel.add("Wide", settingsButton);
	

		Panel plotPanel = prob.defPlotPanel(this);


		tracker = new MediaTracker(this);
		images = prob.getImageArray();
		if (images != null) {
		  for (int i= 0; i < images.length; i++) {
		    tracker.addImage(images[i],i);
		  }
		  try {
		    //start downloading the images. Wait until they're loaded.
		    tracker.waitForAll();
		  }
		  catch (InterruptedException e) {}
		}
  
  
		/*
		Panel plotPanel = new Panel();
		plotPanel.setLayout(new BorderLayout());
		
		String probLabel = prob.getGraphicsLabel();
		//plotPanel.add("North", new Label("Approximation"));
		plotPanel.add("North", new Label(probLabel));
		
		//plot = new XYPlot();
		plot = prob.getGraphics();
		
		plotPanel.add("Center", plot);
		*/
		
		Panel bkgdPanel = new Panel();
		bkgdPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		//bkgdPanel.setLayout(new FlowLayout());
		//bkgdPanel.add(new Label("Continue running applet in the background when you leave this page ? "),Label.RIGHT);
		//bkgdPanel.add("Left",new Label("Continue running applet in the background when you leave this page ?",Label.LEFT));
		bkgdPanel.add("Wide Tall Flush", new Label("Continue running applet in the background when you leave this page ?   ",Label.LEFT));

		bkgdChoice = new Choice();
		bkgdChoice.addItem("YES                       ");
		bkgdChoice.addItem("NO");
		//bkgdPanel.add("Left",bkgdChoice);
		bkgdPanel.add("Top", bkgdChoice);


		//draw option panel
		Panel drawPanel = new Panel();
		//drawPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		drawPanel.setLayout(new FlowLayout());
		drawPanel.add(new Label("Show the trail generated by the best program in the generation ? ",Label.LEFT));

		drawChoice = new Choice();
                                drawChoice.addItem("NO, not at all ");
		drawChoice.addItem("YES, after the run");
		drawChoice.addItem("YES, after each generation");
		drawPanel.add(drawChoice);



		Panel histoPanel = new Panel();
		histoPanel.setLayout(new BorderLayout());
		histoPanel.add("North", new Label("Fitnesses"));
		//histogram = new Histogram();
		//histogram = new Histogram(prob);
		histogram = prob.createHistogram();
		//histogram = new Histogram(0.0, 0.0, 1.0, 1.0); 
		histoPanel.add("Center", histogram);
		
		Panel resultsPanel = new Panel();
		resultsPanel.setLayout(new BorderLayout());
		resultsPanel.add("North", new Label("Results"));
		results = new TextArea();
		resultsPanel.add("Center", results);
		
		Panel statusPanel = new Panel();
		statusPanel.setLayout(new BorderLayout());
		statusPanel.add("North", new Label("Status"));
		status = new TextArea();
		statusPanel.add("Center", status);
		
		Panel outputPanel = new Panel();
		FractionalLayout outputLayout = new FractionalLayout();
		outputPanel.setLayout(outputLayout);

		/*
		outputLayout.setConstraint(plotPanel, new FrameConstraint(
				0.0, 4,
				0.0, 0,
				0.5, -4,
				0.5, 0));
		outputPanel.add(plotPanel);
		outputLayout.setConstraint(histoPanel, new FrameConstraint(
				0.0, 4,
				0.5, 0,
				0.5, -4,
				1.0, 0));
		outputPanel.add(histoPanel);
		*/

		outputLayout.setConstraint(plotPanel, prob.getPlotFrameConstraint());
		outputPanel.add(plotPanel);

		outputLayout.setConstraint(histoPanel, prob.getHistoFrameConstraint());
		outputPanel.add(histoPanel);

		outputLayout.setConstraint(statusPanel, new FrameConstraint(
				0.5, 4,
				0.0, 0,
				1.0, 0,
				0.2, 0));
		outputPanel.add(statusPanel);
		outputLayout.setConstraint(resultsPanel, new FrameConstraint(
				0.5, 4,
				0.2, 0,
				1.0, 0,
				1.0, 0));
		outputPanel.add(resultsPanel);

		Panel hozPanel = new Panel();
		hozPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL, 8));
		hozPanel.add("Wide Tall Flush", outputPanel);
		hozPanel.add("Top", buttonPanel);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", hozPanel);
		//add ("Bottom", drawPanel);
		if (! Application) {
		  add("Bottom", bkgdPanel);
		}
		add ("Bottom", drawPanel);

		/*
		setLayout(new StackLayout(StackLayout.HORIZONTAL, 8));
		add("Wide Tall Flush", outputPanel);
		add("Top", buttonPanel);
		*/
		/*
		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", outputPanel);
		add("Bottom Wide", buttonPanel);
		*/

		startButton.enable(false);
		pauseButton.enable(false);
		stopButton.enable(false);
		settingsButton.enable(false);
		//gp = new GP(seed,genToExport);
		//gp = new GP(prob,seed);
		//System.out.println("going to create gp object");
		
		/*
		if (Application) {
		  //LoadFileDialog fd = new LoadFileDialog(frame);
		  
		  Dialog fd = new LoadFileDialog(Dialog.findFirstFrame(this));
		  fd.show();
		  m = new ThreadMonitor();
		  m.waitUntilFinishes();
		  //popFileName = getPopFile();
		  //popFileName = JOptionPane.showInputDialog(null,"Enter File Name","Title",JOptionPane.QUESTION_MESSAGE);
		  System.out.println("popFileName specified by user is " + popFileName);
		  
		}  
		*/
		
		//validate();
		//System.out.println("Validate() called.");

		/*
		if (Application) {
		  frame.show();
		  frame.resize(frame.insets().left + frame.insets().right  + 628,
			       frame.insets().top  + frame.insets().bottom + 617);
		  
		  frame.setLocation(30,30);
		}
		*/
		/*
		boolean NoConnection = true;

		while (NoConnection) {
		  //status.setText("Obtaining seed from server ...");
		  try {
		    //imigrant i;
		    //System.out.println("application ? " + Application);
		    //imigrant i = (imigrant)Naming.lookup("rmi://" + "studentweb.cs.bham.ac.uk" + "/importImigrant");
		    if (! Application) {
		      //String appletURL = "//" + getCodeBase().getHost() + "/importImigrant";
		      //System.out.println("appletURL : " + appletURL); 
		      //i = (imigrant)Naming.lookup("//" + applet_DGP.getCodeBase().getHost() + "/importImigrant");
		      i = (imigrant)Naming.lookup("//" + "hamm.cs.bham.ac.uk" + "/importImigrant");
		    }
		    else { 
		      i = (imigrant)Naming.lookup("rmi://" + "hamm.cs.bham.ac.uk" + "/importImigrant");
		    }
		    //imigrant i = (imigrant)Naming.lookup("rmi://" + line + "/importImigrant");
		    //String status = i.receiveImigrant(goodIndividual,thisHost);
		    //status = i.receiveImigrant(individualArray,thisHost);
		    //System.out.println(status);
		    if ((! Application) || (Application && (popFileName == null))) { 
		      //System.out.println("Getting seed from server application");
		      seed = i.getSeed();
		      System.out.println("Seed obtained from server is " + seed);
		      //status.setText("Seed obtained from server.");
		    }
		    NoConnection = false;
		  }
		  catch (Exception e) {
		  //catch (RemoteException e) {
		    System.out.println("Exception in exportIndividual: " + e);
		    //status.setText("Cannot obtain seed from Server.\nModem may NOT be ON !");
		    
		    ModemDialog n = new ModemDialog(Dialog.findFirstFrame(this),"Could not connect to Server to retrieve Seed !\nPlease check that your modem is powered ON.", "Network Problem");
		    n.show();
		    n.pack();
		    
		    if (! n.getDialogAns()) {
		      NoConnection = false;
		      //status.setText("Abandon obtaining seed from server.\nDefault seed used instead.");
		    }
		    
		    //System.out.println("Waiting for 2 mins for connection to be started");
		    //new ThreadMonitor().waitUntilTimeOut(1200); //wait for 2 mins
		    //System.out.println("Wait expires. Checking communication link again.");
		  } 
		}
		*/

		//System.out.println("Seed to be passed to gp is " + seed);
		//System.out.println("popFileName to be passed to gp is " + popFileName);
		
		gp = new GP(prob,seed,popFileName,this);
		//gp = new GP(prob);
		gp.addObserver(this);
		startButton.enable(true);

		if ((Application) && (popFileName != null) && (new File(popFileName).exists())) {
		  settingsButton.enable(false);
		}
		else {
		  settingsButton.enable(true);
		}

		gp.init();
		
		//validate();
		//System.out.println("Validate() called ");

		/* starting the ImportImigrant server */
		/* System.setSecurityManager(new RMISecurityManager()); */ 
		/*
		try {
		  ImportImigrant h = new ImportImigrant();
		  Naming.rebind("importImigrant",h);
		  System.out.println("ImportImigrant server ready");
		  //fout.println("ImportImigrant server ready");
		}
		catch (RemoteException re) {
		  System.out.println("Exception in DGPClient.init() : " + re);
		  //fout.println("Exception in DGPClient.init() : " + re);
		}
		catch (MalformedURLException e) {
		  System.out.println("MalformedURLException in DGPClient.init() : " + e);
		  //fout.println("MalformedURLException in DGPClient.init() : " + e);
		}
		*/
		
	}


	/**
	destroy() is called when the applet is terminating and being unloaded.
	*/
	public void destroy() {
		gp.stop();
	}


	/**
	The start() method is called when the page containing the applet appears
	in the browser.
	If the user moves to another page while the GP algorithm
	is running, the GP thread is suspended. When returning to the page with
	our applet, the GP thread resumes.
	*/
	public void start()	{
	  gp.thaw();
	}
	

	/**	The stop() method is called when the page containing the applet is
	no longer on the screen.
	If the user moves to another page while the GP algorithm
	is running, the GP thread is suspended. When returning to the page with
	our applet, the GP thread resumes.
	*/
	public void stop() {
	  gp.freeze();
	}


	/**
	action() is called whenever one of the command buttons is pressed.
	The button that was pressed is disabled immediately to avoid races.
	Only when the GP notifies the applet of a state change (via update()),
	the appropriate	buttons are re-enabled.	
	*/
	public synchronized boolean action(Event evt, Object what) {
		if (evt.target == startButton) {
			startButton.enable(false);
			settingsButton.enable(false);
			//gp.start(seed);
			gp.start();
			return true;
		}
		if (evt.target == pauseButton) {
			pauseButton.enable(false);
			int state = gp.getState();
			switch (state) {
				case GP.STARTED:
				case GP.RESUMED:
					gp.suspend();
					break;
				case GP.SUSPENDED:
					gp.resume();
					break;
				default:
					break;
			}
			return true;
		}
		if (evt.target == stopButton) {
			stopButton.enable(false);
			pauseButton.enable(false);
			gp.stop();
			return true;
		}
		if (evt.target == settingsButton) {
			settingsButton.enable(false);
			startButton.enable(false);
			
			Dialog d = new SettingsDialog(Dialog.findFirstFrame(this), gp, prob);
			d.show();

			/*
			Component p = new SettingsPanel(gp, prob);

			ScrollPane pane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
			setLayout(new BorderLayout());
			pane.add(p);
			//add("Center", pane);
			
			Dialog sd = new SettingsScroll(Dialog.findFirstFrame(this), pane);
			sd.show();
			*/

			settingsButton.enable(true);
			startButton.enable(true);
			return true;
		}
		return false;
	}


	/**
	Is called whenever the GP model changes. The views on the model
	-- which are contained here in the applet -- are updated accordingly.
	*/
	public void update(Observable o, Object  arg) {
		if (arg instanceof GPMessageStateChanged) {
			GPMessageStateChanged msg = (GPMessageStateChanged)arg;
			switch (msg.newState) {
				case GP.STARTED:
					startButton.enable(false);
					pauseButton.enable(true);
					stopButton.enable(true);
					settingsButton.enable(false);
					//prob.plot.setTrace(1, null);
					//prob.plot.setTrace(2, null);
					((Plot)prob.getPlot()).setTrace(1, null);
					((Plot)prob.getPlot()).setTrace(2, null);
					results.setText("");
					histogram.setData(null);
					status.setText("Starting up...");
					break;
				case GP.SUSPENDED:
					startButton.enable(false);
					pauseButton.enable(true);
					pauseButton.setLabel("Resume");
					stopButton.enable(true);
					settingsButton.enable(false);
					status.setText("Paused");
					break;
				case GP.RESUMED:
					startButton.enable(false);
					pauseButton.enable(true);
					pauseButton.setLabel("Pause");
					stopButton.enable(true);
					settingsButton.enable(false);
					status.setText("Resuming...");
					break;

				case GP.STOPPED:

					status.setText("Stopped\n" + msg.text);
/*
				                if (experiment) {
                                                                                   nrOfRuns = nrOfRuns - 1;
                                                                                   if (nrOfRuns >= 0) {
                                                                                       gp.start();
                                                                                   }
                                                                                }
*/
					startButton.enable(true);
					pauseButton.enable(false);
					pauseButton.setLabel("Pause");
					stopButton.enable(false);
					settingsButton.enable(true);
					break;
			}
		}
		if (arg instanceof GPMessageFitnessCasesSet) {
			GPMessageFitnessCasesSet msg = (GPMessageFitnessCasesSet)arg;
			//plot.setTrace(0, msg.data);
			//prob.plot.setTrace(0, msg.data);
			((Plot)prob.getPlot()).setTrace(0, msg.data);
		}
		if (arg instanceof GPMessageEvaluatingIndividual) {
			GPMessageEvaluatingIndividual msg = (GPMessageEvaluatingIndividual)arg;
			//status.setText("Evaluating individual #" + msg.individualNr + "\n" +
			//		"of generation " + msg.generationNr);
			//plot.setTrace(1, msg.data);
			//prob.plot.setTrace(1, msg.data);

			((Plot)prob.getPlot()).setTrace(1, msg.data);
		}
		if (arg instanceof GPMessageBestFound) {
			GPMessageBestFound msg = (GPMessageBestFound)arg;
			//plot.setTrace(2, msg.data);
			//prob.plot.setTrace(2, msg.data);
			((Plot)prob.getPlot()).setTrace(2, msg.data);
			
			/* message originally designed for use with elitism but has been changed because
			   elitism is not used here. */
			/*
			results.setText("The best individual so far\n" +
					"was found in generation " +
					msg.generation + ".\n" +
					"Its adjusted fitness is " + msg.fitness + "\n\n" +
					"Its function is:\n\n" + 
					msg.program); */
			
			results.setText("The best individual found\n" +
					"in generation " +
					msg.generation + "\n" +
					"has " + prob.getFitnessType() + " of " + msg.fitness + "\n\n" + 
					//adjusted fitness of " + msg.fitness + "\n\n" +
					"Its function is:\n\n" + 
					msg.program);

		}
		if (arg instanceof GPMessageEvaluatingPopulation) {
			GPMessageEvaluatingPopulation msg = (GPMessageEvaluatingPopulation)arg;
			//plot.setTrace(1, null);
			//prob.plot.setTrace(1, null);
			((Plot)prob.getPlot()).setTrace(1, null);
			histogram.setData(msg.fitness);
		}

		if (arg instanceof GPMessageStatus) {
			GPMessageStatus msg = (GPMessageStatus)arg;
			status.setText(msg.text);
		}

		if (arg instanceof GPMessageResults) {
			GPMessageResults msg = (GPMessageResults)arg;
			results.setText(msg.text);
		}

	}

  
  /**
  * Get the user to specify the file containing the saved population and seed.
  */    
  /* 
  void getFileName() {
    Dialog fd = new LoadFileDialog(Dialog.findFirstFrame(this));
    fd.show();		  
    System.out.println("popFileName specified by user is " + popFileName);
  }
  */
}











