package bham.cs.fsc.gp;

import bham.cs.fsc.ui.*;
//import gp.approx.ui.*;
import java.io.Serializable;

/**
* modified by Phyllis Chong to be generic and distributed.
*
* A GP object sends this message to its observers whenever
* the genetic algorithm has evaluated the fitness of an individual.
*
* @version 1.0
* @author Hans U. Gerber (<a href="mailto:gerber@ifh.ee.ethz.ch">gerber@ifh.ee.ethz.ch</a>)
*/
public class GPMessageEvaluatingIndividual extends GPMessage implements Serializable {
  //public int generationNr;
  //public int individualNr;
        //public RealPoint[] data;
        public PlotData[] data;
        //GPMessageEvaluatingIndividual(int generationNr, int individualNr, RealPoint[] data) {
  //public GPMessageEvaluatingIndividual(int generationNr, int individualNr, PlotData[] data) {
  public GPMessageEvaluatingIndividual(PlotData[] data) {
    //this.generationNr = generationNr;
    //this.individualNr	= individualNr;
		this.data = data;
	} 
}

