package bham.cs.fsc.gp.approx;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.ui.*;

public class Division extends Function implements Serializable {

	public Division() {
		arg = new Program[2];
	}

	public String getName() {
		return "div";
	}

	public double eval(double x) {
		double divisor = arg[1].eval(x);
		return (divisor == 0 ? 1 : arg[0].eval(x) / divisor);
	}

}
