package bham.cs.fsc.ui;

import java.io.*;
import java.awt.TextArea;
import java.awt.Font;

/**
* modified by Phyllis Chong to be generic and distributed.
*
* This class combines the data model and the view to inspect and
* edit a series of x-y value pairs.
* The model stores both a raw text representation and the same data
* converted into an array of points.
* The raw text is stored because the user may embed comments into
* his input. These comments would get lost if only the numeric point
* data was stored.
*
* @version 1.0
* @author Hans U. Gerber (<a href="mailto:gerber@ifh.ee.ethz.ch">gerber@ifh.ee.ethz.ch</a>)
*/

public interface PlotUI extends Validatable {
  //public String getLabel();
  //public void display();
  public PlotData[] get();
  //public String check();
  //public void accept();
  //PlotData[] read(String s);

}


