//package exp;
package bham.cs.fsc.exp;
import java.applet.*;
import java.awt.Graphics;
import java.awt.Rectangle;
//import ApproxFrame;
import DGPFrame;
import bham.cs.fsc.ui.*;
import java.awt.Button;
import java.awt.Event;
import java.awt.Font;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.TextArea;
import java.awt.Label;
import java.awt.Color;
import java.awt.Panel;
import java.awt.BorderLayout;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.exp.*;
import java.util.Observer;
import java.util.Observable;
import java.io.*;
import java.net.*;
import java.rmi.*;

//import gp.approx.ui.*;


/*
This applet is a generic program which demonstrates the following problems :
1) symbolic regression
2) artificial ant following the Santa Fe trail
3) artificial ant following the Los Altos Hills trail

The code is adapted from the symbolic regression GP program coded by Hans U.Gerber.

Note that it runs as a standalone Java application as well.

@version 1.0
@author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/

//public class DGPServer extends Applet implements Observer {
public class DGPServer {

	// STANDALONE APPLICATION SUPPORT
	//		m_fStandAlone will be set to true if applet is run standalone
	public boolean m_fStandAlone = false;

	Button startButton;
	Button pauseButton;
	Button stopButton;
	Button settingsButton;
        //XYPlot plot;
	Histogram histogram;
	TextArea status;
	TextArea results;
  //***GP gp;
  
        Problem prob;
        static String probName = "Approx";

        static int seed = 12345;
        static String host = "";
        PrintStream fout;
        //static int genToExport = 10;
        static String fileName = "ClientListD.dat";

        static String title ="";

        public static Random popRandom;

	/**
	The main() method acts as the applet's entry point when it is run
	as a standalone application.
	It is ignored if the applet is run from	within an HTML page.
	*/
	public static void main(String args[]) {

	  switch (args.length) {
	  case 0 : 
	    break;
	  case 1 :
	    probName = args[0];
	    break;
	  case 2 :
	    probName = args[0];
	    seed = Integer.parseInt(args[1]); 
	    break;
	 default :
	    probName = args[0];
	    seed = Integer.parseInt(args[1]);
	    fileName = args[2];
	    break;   

	  }
  
	  try {
	    host = new String(InetAddress.getLocalHost().getHostName());
	  }
	  catch (java.net.UnknownHostException e) {
	    System.out.println("UnknownHostException in DGP.init() : " + e);
	    host = "unknown" ;
	  }

	  popRandom = new Random(seed);
	  popRandom.setSeed(seed);

	  title = "Workstation : " + host + "          Problem : " + probName;

	  System.setSecurityManager(new RMISecurityManager()); 
		try {
		  ImportImigrant h = new ImportImigrant();
		  Naming.rebind("importImigrant",h);
		  System.out.println("ImportImigrant server ready");
		  //fout.println("ImportImigrant server ready");
		}
		catch (RemoteException re) {
		  System.out.println("Exception in DGP.init() : " + re);
		  //fout.println("Exception in DGP.init() : " + re);
		}
		catch (MalformedURLException e) {
		  System.out.println("MalformedURLException in DGP.init() : " + e);
		  //fout.println("MalformedURLException in DGP.init() : " + e);
		}	
	}
  
}











