package bham.cs.fsc.gp;

import java.io.Serializable;

/**
* A GP object sends this message to its observers whenever
* a population is saved or loaded from a file for a Java application.
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class GPMessageStatus extends GPMessage implements Serializable {
	public String text;
public	GPMessageStatus(String text) {
		this.text = text;
	}
}

