//package gp;
package bham.cs.fsc.gp;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.ui.*;
//import gp.*;

/**
* This class combines a program and its computed fitness values.
*/

public class Individual implements Serializable {
	public Program program;
	public double standardizedFitness;
	public double adjustedFitness;
        public double normalizedFitness;
	public int hits;
        public boolean sent;


	Individual(Program p) {
		program = (Program)p.clone();
		standardizedFitness = 0.0;
		adjustedFitness = 0.0;
		normalizedFitness = 0.0;
		hits = 0;
		sent = false;
	}

	Individual copy() {
		Individual newInd = new Individual(this.program);
		newInd.standardizedFitness = this.standardizedFitness;
		newInd.adjustedFitness = this.adjustedFitness;
		newInd.normalizedFitness = this.normalizedFitness;
		newInd.hits = this.hits;
		newInd.sent = this.sent;
		return newInd;
	}

}

