package bham.cs.fsc.gp.ant;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.ui.*;

public class IfFoodAhead extends Function implements Serializable {

        int Xahead;
        int Yahead;

	public IfFoodAhead() {
		arg = new Program[2];
	}

	public String getName() {
		return "IF-FOOD-AHEAD";
	}
  
        //public double eval() {
        //public double eval(double gridLimit) {
        public double eval(double x) {

	  //**System.out.println("evaluating IfFoodAhead");

	  /*stopEval checking is not required because either no terminals are evaluated before this or checking would 
	  have been done at the PROGNx preceding this function.*/
 
	  //if (! Ant.stopEval()) {

	  //**System.out.println("ant facing " + Ant.facing);
	  //**System.out.println("ant's current position : " + Ant.X + "," + Ant.Y);

	  switch (Ant.facing) {

	  case Ant.NORTH :
	    //**System.out.println("in North. Position ahead is X,Y-1");
	    Xahead = Ant.X;
	    //Yahead = Ant.getNewYCoordinate(Ant.Y - 1, gridLimit);
	    Yahead = Ant.getNewYCoordinate(Ant.Y - 1);
	    break;

	  case Ant.SOUTH :
	    //**System.out.println("in South. Position ahead is X,Y+1");
	    Xahead = Ant.X;
	    //Yahead = Ant.getNewYCoordinate(Ant.Y + 1, gridLimit);	 
	    Yahead = Ant.getNewYCoordinate(Ant.Y + 1);	
	    break;
	    
	  case Ant.EAST :
	    //**System.out.println("in East. Position ahead is X+1,Y");
	    //Xahead = Ant.getNewXCoordinate(Ant.X + 1, gridLimit);
	    Xahead = Ant.getNewXCoordinate(Ant.X + 1);
	    Yahead = Ant.Y; 
	    break;

	  case Ant.WEST :
	    //**System.out.println("in West. Position ahead is X-1,Y");
	    //Xahead = Ant.getNewXCoordinate(Ant.X - 1, gridLimit);
	    Xahead = Ant.getNewXCoordinate(Ant.X - 1);
	    Yahead = Ant.Y;
	    break;
	  }

	  //**System.out.println("Ant's ahead position : " + Xahead + "," + Yahead);

	  if (Ant.food[Xahead][Yahead]) {
	    //**System.out.println("Ant's ahead position has food, evaluating arg 0");
	    //arg[0].eval();
	    arg[0].eval(1.0);
	  }
	  else {
	    //**System.out.println("Ant's ahead position has no food, evaluating arg 1");
	    //arg[1].eval();
	    arg[1].eval(1.0);
	  }
	  //}
	 return 1.0; 
	}
}















